﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
'Class module
'version 1.20
'See this page for the list of constants:
'http://developer.android.com/intl/fr/reference/android/hardware/Camera.Parameters.html
'Note that you should use the constant values instead of the names.
Sub Class_Globals
	Private nativeCam As Object, FacialSet As Boolean 
	Private cam As Camera ,CamIsInitialized As Boolean
	Private r As Reflector
	Private target As Object
	Private event As String
	Public Front As Boolean, IsPreviewing As Boolean, CameraIsReady As Boolean 'switch to 2 orientation values, one for front, one for back
	Type CameraInfoAndId (CameraInfo As Object, Id As Int)
	Type CameraSize (Width As Int, Height As Int)
	Type Face(ID As Int, score As Int, Location As Rect)', leftEye As Point, mouth As Point, rightEye As Point)
	Private parameters As Object, PreviewWidth As Int, PreviewHeight As Int', JPG As Jpeg
	
	Public EffectsSupported As List, CurrentEffect As String, PreviousSize As CameraSize, ActualOrientation As Int = -1
	Public EFFECT_NONE As String = "none", EFFECT_MONO As String = "mono", EFFECT_NEGATIVE As String = "negative", EFFECT_SOLARIZE As String = "solarize", EFFECT_SEPIA As String = "sepia"
	Public EFFECT_WHITEBOARD As String = "whiteboard", EFFECT_BLACKBOARD As String = "blackboard", EFFECT_AQUA As String = "aqua", EFFECT_POSTERIZE As String = "posterize"
	
	Private FrontCamReg As Rect, RearCamReg As Rect, LastReg As Rect, AllRegions As Map 
	Public IsDefault As Boolean, NeedsSaving As Boolean, MaxFaces As Int = -1'0=front,1=rear,2=last face detected
End Sub

'0=up, 1=right, 2=down, 3=left
Sub GetOrientation As Int
	Dim r As Reflector
	r.Target = r.GetActivity
	r.Target = r.RunMethod("getWindowManager")
	r.Target = r.RunMethod("getDefaultDisplay")
	Return r.RunMethod("getRotation")
End Sub

Public Sub Initialize (Panel1 As Panel, FrontCamera As Boolean, TargetModule As Object, EventName As String) As Boolean
	ActualOrientation = GetOrientation
	target = TargetModule
	event = EventName
	Front = FrontCamera
	Panel1.Visible=True
	PreviewWidth = Panel1.Width
	PreviewHeight = Panel1.Height
	Dim id As Int = FindCamera(Front).id
	If id = -1 Then
		Front = Not(Front) 'try different camera
		id = FindCamera(Front).id
		If id = -1 Then 
			'If SubExists(target, event & "_ready") Then CallSub2(target, event & "_ready", False) Else Log(event & "_ready is missing/required")
			Return False
		End If
	End If
	'JPG.Initialize("JPEG")
	cam.Initialize2(Panel1, "camera", id)
	CurrentEffect=""
	CameraIsReady=False
	CommitParameters
	ForceReset
	Log("STAGE 1: INITIALIZED")
	Return True 
End Sub

Private Sub FindCamera (FrontCamera As Boolean) As CameraInfoAndId
	Dim ci As CameraInfoAndId, cameraInfo As Object, cameraValue As Int, numberOfCameras As Int = r.RunStaticMethod("android.hardware.Camera", "getNumberOfCameras", Null, Null)
	If FrontCamera Then cameraValue = 1 Else cameraValue = 0
	Try
		cameraInfo = r.CreateObject("android.hardware.Camera$CameraInfo")
		For i = 0 To numberOfCameras - 1
			r.RunStaticMethod("android.hardware.Camera", "getCameraInfo", Array As Object(i, cameraInfo), Array As String("java.lang.int", "android.hardware.Camera$CameraInfo"))
			r.target = cameraInfo
			If r.GetField("facing") = cameraValue Then
				ci.cameraInfo = r.target
				ci.Id = i
				Return ci
			End If
		Next
	Catch
		Log("FindCamera: " & LastException)
	End Try
	ci.id = -1
	Return ci
End Sub

Private Sub SetDisplayOrientation
	r.target = r.GetActivity
	r.target = r.RunMethod("getWindowManager")
	r.target = r.RunMethod("getDefaultDisplay")
	r.target = r.RunMethod("getRotation")
	Dim previewResult As Int, result As Int, degrees As Int = r.target * 90, ci As CameraInfoAndId = FindCamera(Front), orientation As Int = r.GetField("orientation")
	r.target = ci.CameraInfo
	If Front Then
		previewResult = (orientation + degrees) Mod 360
		result = previewResult
		previewResult = (360 - previewResult) Mod 360
	Else
		previewResult = (orientation - degrees + 360) Mod 360
		result = previewResult
		'Log(previewResult)
	End If
	r.target = nativeCam
	r.RunMethod2("setDisplayOrientation", previewResult, "java.lang.int")
	r.target = parameters
	r.RunMethod2("setRotation", result, "java.lang.int")
	CommitParameters
End Sub

Private Sub Camera_Ready (Success As Boolean)
	CamIsInitialized=Success
	If Success Then
		Try
			r.target = cam
			nativeCam = r.GetField("camera")
			r.target = nativeCam
			parameters = r.RunMethod("getParameters")
			SetDisplayOrientation
			CurrentEffect=""
			CameraIsReady = False
			If Not(EffectsSupported.IsInitialized) Then EffectsSupported = GetSupportedColorEffects
		Catch
			Success=False
			Log("Camera_Ready: " & LastException)
		End Try
	End If
	If SubExists(target, event & "_ready") Then CallSub2(target, event & "_ready", Success) Else Log(event & "_ready is missing/required")
End Sub

Sub Camera_Preview (Data() As Byte)
	Dim NewOrientation = GetOrientation, OldOrientation As Int = ActualOrientation
	CameraIsReady=True
	If OldOrientation <> NewOrientation Then
		ActualOrientation = NewOrientation
		Log("STAGE 4: ROTATE FROM " & OldOrientation & " TO: " & NewOrientation)
		LoadRegionOrientation(OldOrientation)
		SetDisplayOrientation
	End If
	If SubExists(target, event & "_preview") Then CallSub2(target, event & "_preview", Data) 'Else Log(event & "_preview is missing")
End Sub

Public Sub TakePicture As Boolean
	If CamIsInitialized Then
		cam.TakePicture
		Return True
	End If
End Sub

Public Sub BytesToBmp(Data() As Byte) As Bitmap', Degrees As Int) As Bitmap
	Dim bm As Bitmap, ips As InputStream', bm2 As BitmapExtended
	ips.InitializeFromBytesArray(Data, 0, Data.Length)
	bm.Initialize2(ips)
	ips.Close
	Return(bm)
	'If Degrees = 0 Then Return(bm)
	'Return bm2.rotateBitmap(bm,-90)
End Sub

Private Sub Camera_PictureTaken (Data() As Byte)
	If SubExists(target, event & "_PictureTaken") Then CallSub2(target, event & "_PictureTaken", Data) 'Else Log(event & "_PictureTaken is missing")
End Sub

Public Sub StartPreview As Boolean
	If Stop Then
		If PreviousSize.IsInitialized Then SetPreviewSize(PreviousSize.Width, PreviousSize.Height)
		cam.StartPreview
		If Not(PreviousSize.IsInitialized) Then PreviousSize = GetPreviewSize
		IsPreviewing=True
		Return True
	End If
End Sub

Public Sub StopPreview As Boolean
	If Stop Then 
		cam.StopPreview
		Return True 
	End If
End Sub

Public Sub Release As Boolean
	If Stop Then 
		cam.Release
		Return True 
	End If
End Sub

private Sub Stop As Boolean 
	If Not(AllRegions.IsInitialized) Then LoadFaceRegions
	If NeedsSaving Then SaveFaceRegions
	If CamIsInitialized Then
		CurrentEffect=""
		CameraIsReady=False
		IsPreviewing=False
		Return True
	End If
End Sub

'Saves the data received from PictureTaken event
Public Sub SavePictureToFile(Data() As Byte, Dir As String, FileName As String)
	Dim out As OutputStream = File.OpenOutput(Dir, FileName, False)
	out.WriteBytes(Data, 0, Data.Length)
	out.Close
End Sub

Public Sub SetParameter(Key As String, Value As String) As Boolean
	'Try
	r.target = parameters
	r.RunMethod3("set", Key, "java.lang.String", Value, "java.lang.String")
	Return True
	'Catch
	'	Log(LastException)
	'End Try
End Sub

Public Sub GetParameter(Key As String) As String
	r.target = parameters
	Return r.RunMethod2("get", Key, "java.lang.String")
End Sub

Public Sub CommitParameters As Boolean 
	Try
		r.target = nativeCam
		r.RunMethod4("setParameters", Array As Object(parameters), Array As String("android.hardware.Camera$Parameters"))
		Return True 
	Catch
		'Log("CommitParameters: " & LastException)
	End Try
End Sub

'Gets and sets the color effect. getColorEffect returns empty string (null) if not supported.
Public Sub GetColorEffect As String
	Return GetParameter("effect")
End Sub

'Only sets the effect if it isn't set to it already
public Sub SetColorEffect2(Effect As String) As Boolean
	'Log("CameraIsReady: " & CameraIsReady & " CurrentEffect: " & CurrentEffect & " (Actual: " & GetColorEffect & ") Index: " & EffectsSupported.IndexOf(Effect))
	If CameraIsReady Then
		If Not(GetColorEffect = Effect) Then
			If EffectsSupported.IndexOf(Effect) > -1 Then
				Return SetColorEffect(Effect)
			End If
		End If
	End If
End Sub

'Retuns a list of supported color effects. List will be be uninitialized (null) if not supported.
'Options: "none" , "mono" , "negative" , "solarize" , "sepia" , "posterize" , "whiteboard" , "blackboard" , "aqua"
'Other:   "aqua" , "emboss" , "sketch" , "neon" , "vintage-warm" , "vintage-cold" , "washed"
Public Sub SetColorEffect(Effect As String) As Boolean
	If SetParameter("effect", Effect) Then
		CommitParameters
		CurrentEffect=Effect
		Return True
	End If
End Sub

'Returns an array of CameraSize types containing the available picture sizes.
'if isPreview=true, then Returns the Preview sizes instead
Public Sub GetSupportedPicturesSizes(isPreview As Boolean) As CameraSize()
	Dim SubName As String, cs(0) As CameraSize
	Try
		If isPreview Then SubName = "getSupportedPreviewSizes" Else SubName = "getSupportedPictureSizes"
		r.target = parameters
		Dim list1 As List = r.RunMethod(SubName)
		Dim cs(list1.Size) As CameraSize
		For i = 0 To list1.Size - 1
			r.target = list1.Get(i)
			cs(i).Width = r.GetField("width")
			cs(i).Height = r.GetField("height")
			Log(SubName & " " & i & " = Width: " & cs(i).Width & " Height: " & cs(i).Height)
		Next
	Catch 
		Log("ENUM FAILED: " & LastException)
		If PreviousSize.IsInitialized Then 
			Dim cs(1) As CameraSize
			cs(0) = PreviousSize
		End If
	End Try 
	Return cs
End Sub
Sub GetClosestSize(IsPreview As Boolean, Width As Int, Height As Int) As CameraSize
	Dim Sizes() As CameraSize = GetSupportedPicturesSizes(IsPreview), temp As Int, Default As CameraSize
	For temp = 0 To Sizes.Length-1'assumes they're sorted from biggest to smallest.
		If Sizes(temp).Width <= Width And Sizes(temp).Height <= Height Then Return Sizes(temp)
	Next
	If PreviousSize.IsInitialized Then 
		Log("Returning PreviousSize: " & PreviousSize.Width & " & " & PreviousSize.Height)
		Return PreviousSize
	Else 
		Default.Initialize
		Default.Width=Width
		Default.Height=Height
		PreviousSize=Default
		Log("Returning Parameters: " & PreviousSize.Width & " & " & PreviousSize.Height)
	End If
	Return Default
End Sub


'Set the picture size. 
Public Sub SetPictureSize(Width As Int, Height As Int)
	r.target = parameters
	r.RunMethod3("setPictureSize", Width, "java.lang.int", Height, "java.lang.int")
End Sub

'Gets or sets the JPeg quality - Range = 1 (Worst) to 100 (Best)
Public Sub GetJpegQuality() As Int
	r.target = parameters
	Return r.RunMethod("getJpegQuality")
End Sub

Public Sub SetJpegQuality(Quality As Int)
	r.target = parameters
	r.RunMethod2("setJpegQuality", Min(100, Max(1,Quality)), "java.lang.int")
End Sub

Public Sub SetFlashMode(Mode As String)
	r.target = parameters
	r.RunMethod2("setFlashMode", Mode, "java.lang.String")
End Sub

'Gets or sets flash mode. getFlashMode returns empty string (null) if feature not supported.
'See: GetSupportedFlashModes
Public Sub GetFlashMode As String
	r.target = parameters
	Return r.RunMethod("getFlashMode")
End Sub

'Returns a list of supported flash modes. List is not initialized (null) if feature not supported.
'Options: "off" , "auto" , "on" , "red-eye" , "torch"
Public Sub GetSupportedFlashModes As List
	r.target = parameters
	Return r.RunMethod("getSupportedFlashModes")
End Sub

Public Sub GetSupportedColorEffects As List
	r.target = parameters
	Return r.RunMethod("getSupportedColorEffects")
End Sub

'Gets and sets the scene modes. getSceneMode returns empty string (null) if not supported.
'See: GetSupportedSceneModes
Public Sub GetSceneMode As String
	Return GetParameter("mode")
End Sub

Public Sub SetSceneMode(Mode As String)
	SetParameter("mode", Mode)
End Sub

'Retuns a list of supported scene modes. List will be be uninitialized (null) if not supported.
'Options: "auto" , "action" , "portrait" , "landcape" , "night" , "night-portrait" , "theatre" , "beach" , "snow"
'         "sunset" , "steadyphoto" , "fireworks" , "sports" , "party" , "candlelight" , "barcode"
'Other:   "asd"
Public Sub GetSupportedSceneModes As List
	r.target = parameters
	Return r.RunMethod("getSupportedSceneModes")
End Sub

'Returns a CameraSize type containing the Width and Height preview size.
Public Sub GetPreviewSize As CameraSize
	Dim cs As CameraSize
	If CamIsInitialized Then 
		r.target = parameters
		r.target = r.RunMethod("getPreviewSize")
		cs.Width = r.GetField("width")
		cs.Height = r.GetField("height")
	End If 
	Return cs
End Sub

'Returns a CameraSize type containing the width and height of the picture size
Public Sub GetPictureSize As CameraSize
	r.target = parameters
	r.target = r.RunMethod("getPictureSize")
	Dim cs As CameraSize
	cs.Width = r.GetField("width")
	cs.Height = r.GetField("height")
	Return cs
End Sub

'Converts a preview image formatted in YUV format to JPEG.
'Note that you should not save every preview image as it will slow down the whole process.
Public Sub PreviewImageToJpeg(data() As Byte, quality As Int) As Byte()
	Dim size, previewFormat As Object
	r.target = parameters
	size = r.RunMethod("getPreviewSize")
	previewFormat = r.RunMethod("getPreviewFormat")
	r.target = size
	Dim width = r.GetField("width"), height = r.GetField("height") As Int
	Dim yuvImage As Object = r.CreateObject2("android.graphics.YuvImage", Array As Object(data, previewFormat, width, height, Null), Array As String("[B", "java.lang.int", "java.lang.int", "java.lang.int", "[I"))
	r.target = yuvImage
	Dim rect1 As Rect
	rect1.Initialize(0, 0, r.RunMethod("getWidth"), r.RunMethod("getHeight"))
	Dim out As OutputStream
	out.InitializeToBytesArray(100)
	r.RunMethod4("compressToJpeg", Array As Object(rect1, quality, out), Array As String("android.graphics.Rect", "java.lang.int", "java.io.OutputStream"))
	Return out.ToBytesArray
End Sub

Public Sub PreviewImageToBMP(data() As Byte, quality As Int, Width As Int, Height As Int, UseOuterBoundary As Boolean ) As Bitmap
	Dim  I As InputStream, temp As Bitmap, temp2 As Bitmap , BG As Canvas ,Size As point , Orientation As Int
	data = PreviewImageToJpeg(data, quality)
	I.InitializeFromBytesArray(data, 0, data.Length)
	temp.Initialize2(I)
	If Orientation = 0 And Width = temp.Width And temp.Height = Height Then
		Return temp
	Else If Orientation = 180 Or Orientation = 0 Then
'		Size = API.Thumbsize(temp.Width,temp.Height,   Width,Height,  True,UseOuterBoundary)
	Else
'		Size = API.Thumbsize(temp.Width,temp.Height,   Height,Width, True,UseOuterBoundary)
	End If
	temp2.InitializeMutable(Size.x,Size.y)
	BG.Initialize2(temp2)
	BG.DrawBitmapRotated( temp, Null, SetRect(0,0, temp2.Width,temp2.Height), Orientation)
	Return temp2
End Sub

Sub SetRect(X As Int, Y As Int, Width As Int, Height As Int) As Rect
	Dim Rect1 As Rect
	Rect1.Initialize(X,Y,X+Width,Y+Height)
	Return Rect1
End Sub

'Returns a list of supported focus modes. Always returns as least one element.
'See getFocusMode and setFocusMode
'Options: "auto" , "infinity" , "macro" , "fixed" , edof" , "continuous-picture" , "continuous-video"
Public Sub GetSupportedFocusModes As List
	r.target = parameters
	Return r.RunMethod("getSupportedFocusModes")
End Sub

'Sets continuous auto focus if available.
'Call this sub between startPreview() and stopPreview()
Public Sub SetContinuousAutoFocus As Boolean 
	Dim modes As List = GetSupportedFocusModes
	If modes.IndexOf("continuous-picture") > -1 Then
		SetFocusMode("continuous-picture")
	Else If modes.IndexOf("continuous-video") > -1 Then
		SetFocusMode("continuous-video")
	Else If modes.IndexOf("continuous") > -1 Then
		SetFocusMode("continuous")
	Else
		Return False 
	End If
	Return True 
End Sub

Public Sub SetFocusMode(Mode As String)
	r.target = parameters
	r.RunMethod2("setFocusMode", Mode, "java.lang.String")
End Sub

'Returns an array of 3 floats for the current focus distances in meters.
'The 3 floats are Near, Optical, Far
Public Sub GetFocusDistances As Float()
	Dim F(3) As Float
	r.target = parameters
	r.RunMethod4("getFocusDistances", Array As Object(F), Array As String("[F"))
	Return F
End Sub

'This method should only be called if you need to immediately release the camera.
'For example if you need to start another application that depends on the camera.
Public Sub CloseNow
	cam.Release
	r.target = cam
	r.RunMethod2("releaseCameras", True, "java.lang.boolean")
End Sub

'Calls AutoFocus and then takes the picture if focus was successfull.
Public Sub FocusAndTakePicture
	cam.AutoFocus
End Sub

Private Sub Camera_FocusDone (Success As Boolean)
	If Success Then TakePicture
End Sub

Public Sub ToggleFlash As String
	Dim flashModes As List = GetSupportedFlashModes, Flash As String = GetFlashMode'[off, auto, on, torch, red-eye]
	If flashModes.IsInitialized = False Then Return False
	If Flash = "off" Then
		If flashModes.IndexOf("torch") > -1 Then
			Flash = "torch"
		Else
			Flash = flashModes.Get((flashModes.IndexOf(Flash) + 1) Mod flashModes.Size)
		End If
	Else
		Flash = "off"
	End If
	SetFlashMode(Flash)
	CommitParameters
	Return Flash
End Sub

'Gets or sets the current zoom for snapshots.
'Call isZoomSupported() to evaluate if the device supports zooming.
'Call GetMaxZoom() to determine the maximum zoom amount available.
Public Sub GetZoom() As Int
	If IsZoomSupported Then
		r.target = parameters
		Return r.RunMethod("getZoom")
	End If
End Sub

Public Sub SetZoom(Value As Int) As Boolean 
	If IsZoomSupported Then
		r.target = parameters
		r.RunMethod2("setZoom", Max(Value,GetMaxZoom), "java.lang.int")
		Return True 
	End If
End Sub

'Returns the the maximum zoom range supported by the device.
'A value of 0 is returned if zooming is not available.
'NOTE: Call this again after any SetPreviewSize() changes.
Public Sub GetMaxZoom() As Int
	If IsZoomSupported Then
		r.target = parameters
		Return r.RunMethod("getMaxZoom")
	End If
End Sub

'Returns True if zooming is supported.
Public Sub IsZoomSupported() As Boolean
	r.target = parameters
	Return r.RunMethod("isZoomSupported")
End Sub

'Gets or sets the white balance. getWhiteBalance returns empty string (null) if not supported.
'See: GetSupportedWhiteBalance
Public Sub GetWhiteBalance As String
	r.target = parameters
	Return r.RunMethod("getWhiteBalance")
End Sub

Public Sub SetWhiteBalance (Mode As String)
	r.target = parameters
	r.RunMethod2("setWhiteBalance", Mode, "java.lang.String")
End Sub

'Returns a list of supported white balance options. See getWhiteBalance/setWhiteBalance
'Options: "auto" , "incandescent" , "fluorescent"" , "warm-fluorescent" , "daylight"
'         "cloudy-daylight" , "twighlight" , "shade"
Public Sub GetSupportedWhiteBalance  As List
	r.target = parameters
	Return r.RunMethod("getSupportedWhiteBalance")
End Sub

'Sets the preview size. This should be called before startPreview().
'The sizes are based on camera orientation (before the image is rotated by the display orientation).
Public Sub SetPreviewSize(Width As Int, Height As Int) As Boolean 
	Dim ClosestSize As CameraSize = GetClosestSize(True, Width, Height)
	Log("Closest preview size to " & Width & " x " & Height & " was: " & ClosestSize.Width & " x " & ClosestSize.Height)
	If CamIsInitialized Then 
		r.target = parameters
		r.RunMethod3("setPreviewSize", Width, "java.lang.int", Height, "java.lang.int")
		Return True 
	End If 
End Sub

'Gets or sets the focus mode. getFocusMode will always return a string value.
'See: GetSupportedFocusModes    (also SetContinuousAutoFocus)
Public Sub GetFocusMode As String
	r.target = parameters
	Return r.RunMethod("getFocusMode")
End Sub








'Returns a list with the supported preview fps. Each item in the list is an array of two ints (minimum value and maximum value).
Public Sub GetSupportedPreviewFpsRange As List
	r.target = parameters
	Return r.RunMethod("getSupportedPreviewFpsRange")
End Sub
'Returns the current preview fps range.
'Range is a two elements array. The minimum value and maximum value will be stored in this array.
Public Sub GetPreviewFpsRange(Range() As Int)
	r.target = parameters
	r.RunMethod4("getPreviewFpsRange", Array As Object(Range), Array As String("[I"))
End Sub

Public Sub SetPreviewFpsRange(MinValue As Int, MaxValue As Int)
	r.target = parameters
	r.RunMethod4("setPreviewFpsRange", Array As Object(MinValue, MaxValue), Array As String("java.lang.int", "java.lang.int"))
End Sub







Public Sub GetExposureCompensation As Int
	r.target = parameters
	Return r.RunMethod("getExposureCompensation")
End Sub

Public Sub SetExposureCompensation(v As Int)
	r.target = parameters
	r.RunMethod2("setExposureCompensation", v, "java.lang.int")
End Sub

Public Sub GetMinExposureCompensation As Int
	r.target = parameters
	Return r.RunMethod("getMinExposureCompensation")
End Sub

Public Sub GetMaxExposureCompensation As Int
	r.target = parameters
	Return r.RunMethod("getMaxExposureCompensation")
End Sub
















Sub GetMaxNumDetectedFaces As Int
	r.target = parameters
	Return r.RunMethod("getMaxNumDetectedFaces")
End Sub 

Public Sub SetFaceDetectionListener As Boolean 
	Dim jo As JavaObject = nativeCam
	If MaxFaces = -1 Then MaxFaces = GetMaxNumDetectedFaces
	If MaxFaces > 0 Then
		Dim e As Object = jo.CreateEvent("android.hardware.Camera.FaceDetectionListener", "FaceDetection", Null)
		jo.RunMethod("setFaceDetectionListener", Array(e))
		FacialSet=True 
		Log("Face detection activated, supports " & MaxFaces & " faces")
		Return True 
	End If 
	Log("Face detection not supported")
End Sub

Sub IsDiff(Reg1 As Rect, Reg2 As Rect) As Boolean
	If Reg1.Left <> Reg2.Left Then Return True 
	If Reg1.Top <> Reg2.Top Then Return True
	If Reg1.Right <> Reg2.Right Then Return True
	If Reg1.Bottom <> Reg2.Bottom Then Return True
End Sub
Private Sub FaceDetection_Event (MethodName As String, Args() As Object) As Object
	
	Dim faces() As Object = Args(0)
	Dim result As String = faces.length & " faccia/faccie trovata/trovate"
	If SubExists(target, event & "_FaceDetected") Then 
		CallSub2(target, event & "_FaceDetected", result) 'Else Log(event & "_FaceDetected is missing")
	End If
	
	Return Null
	
	Dim Location As Rect, Face As Face, Index As Int, CurrentReg As Rect = FaceRegions(-1), CopyReg As Rect
	Dim tempX As Int, tempY As Int, FaceWidth As Int, FaceHeight As Int, AreaWidth As Int = PreviewWidth, AreaHeight As Int = PreviewHeight	
	CopyReg.Initialize(CurrentReg.Left, CurrentReg.Top, CurrentReg.Right,CurrentReg.Bottom)
	For Each f As Object In faces
		Dim jo As JavaObject = f
		Face.Initialize
		Face.ID = jo.GetField("id")
		If Face.ID = -1 Then Face.ID = Index
		Face.Score = jo.GetField("score")
		Location = jo.GetField("rect")
		LastReg = Location
		'NEXUS 5	(-1000, -1000) represents the top-left of the camera field of view, and (1000, 1000) represents the bottom-right of the field of view.
		'Orientation	X axis			Y axis		DIR		Act		FLIP	NOTES
		'0:		X= 1000 to -1000	Y=-1000 to 1000	O--- 	1		NO
		'180:   X=-1000 to 1000 	Y=1000 to -1000	---O 	3		NO
		'270:	Y=1000 to -1000 	X=1000 to -1000 ^(up) 	0		YES
		'90:	Y=-1000 to 1000 	X=-1000 to 1000 v(down) 2		YES		NOT TESTABLE DUE TO GOOGLE'S INCOMPETENCE
		
		'Sony xperia L and Sony xperia M
		'coordinates which has origin (0,0) at right top corner of the screen for portrait
		Select Case ActualOrientation
			Case 1'0'1		X= 1000 to -1000	Y=-1000 to 1000	O--- (LEFT)
				'Face.Location = SetRect(ScaleFace(Location.Left, PreviewWidth, True), ScaleFace(Location.Top, PreviewHeight, False), Location.Width, Location.Height)
				tempX=-Location.Left'TRUE
				tempY=Location.Top
				FaceWidth=Location.Width
				FaceHeight=Location.Height
			Case 3'180'3	X=-1000 to 1000 	Y=1000 to -1000	---O (RIGHT)
				'Face.Location = SetRect(ScaleFace(Location.Left, PreviewWidth, False), ScaleFace(Location.Top, PreviewHeight, True), Location.Width, Location.Height)
				tempX=Location.Left
				tempY=-Location.Top'TRUE
				FaceWidth=Location.Width
				FaceHeight=Location.Height
				
				
			Case 0'270'0	Y=1000 to -1000 	X=1000 to -1000 ^(up) (FLIPPED AXIS!)
				'Face.Location = SetRect(ScaleFace(Location.Top, PreviewHeight, True), ScaleFace(Location.Left, PreviewWidth, True), Location.Height, Location.Width)
				tempX=-Location.Top'TRUE
				tempY=-Location.Left'TRUE
				FaceWidth=Location.Height
				FaceHeight=Location.Width
				AreaWidth=PreviewHeight
				AreaHeight=PreviewWidth
			Case 2'90'2		Y=-1000 to 1000 	X=-1000 to 1000 v(down) (FLIPPED AXIS!) - NOT TESTABLE (UPSIDE DOWN)
				'Face.Location = SetRect(ScaleFace(Location.Top, PreviewHeight, False), ScaleFace(Location.Left, PreviewWidth, False), Location.Height, Location.Width)
				tempX=Location.Top
				tempY=Location.Left
				FaceWidth=Location.Height
				FaceHeight=Location.Width
				AreaWidth=PreviewHeight
				AreaHeight=PreviewWidth
		End Select
		
		CurrentReg.Left = Min(CurrentReg.left, tempX)
		CurrentReg.Right = Max(CurrentReg.Right, tempX + FaceWidth)
		CurrentReg.Top = Min(CurrentReg.Top, tempY)
		CurrentReg.Bottom = Max(CurrentReg.Bottom, tempY + FaceHeight)
		If IsDiff(CopyReg,CurrentReg) Then NeedsSaving = True 
		Face.Location = SetRect(ScaleFace2(CurrentReg.Left, CurrentReg.Right, tempX, AreaWidth), ScaleFace2(CurrentReg.Top, CurrentReg.Bottom, tempY, AreaHeight), FaceWidth, FaceHeight)
		
		'Log("Location X: " & Location.Left & " Y: " & Location.Top & " O: " & ActualOrientation & " BECOMES X: " & Face.Location.Left & " Y: " & Face.Location.Top & " W: " & FaceWidth & " H: "  & FaceHeight & " NS: " & NeedsSaving)
		
		'Face.mouth = GetPositionOf(jo, "mouth")
		'Face.leftEye = GetPositionOf(jo, "leftEye")
		'Face.rightEye = GetPositionOf(jo, "rightEye")
		'Log("Mouth: " & Face.mouth.X & ", " & Face.mouth.Y & " Leye: " & Face.leftEye.X & ", " & Face.leftEye.Y & " Reye: " & Face.rightEye.X & ", " & Face.rightEye.Y)

		If SubExists(target, event & "_FaceDetected") Then CallSub2(target, event & "_FaceDetected", Face) 'Else Log(event & "_FaceDetected is missing")
		Index=Index+1
	Next
	'SaveRegion(-1, CurrentReg)
	'https://developer.android.com/reference/android/hardware/Camera.Face.html
	Return Null
End Sub

Sub ScaleFace2(Left As Int, Right As Int, Value As Int, Size As Int) As Int 
	Dim Range As Int = Right - Left
	If Range = 0 Then Return ScaleFace(Value, Size, False)
	Return (Value - Left) / Range * Size 
End Sub
'RegionID: -1=Current camera, 0=front, 1=rear
Sub SaveRegion(RegionID As Int, Region As Rect)
	If RegionID = -1 Then RegionID = CurrentRegion
	Select Case RegionID
		Case 0: FrontCamReg=Region
		Case 1: RearCamReg=Region
		Case 2: LastReg=Region
	End Select
	NeedsSaving=True 
End Sub
'RegionID: -1=Current camera, 0=front, 1=rear
Sub FaceRegions(RegionID As Int) As Rect
	If RegionID = -1 Then RegionID = CurrentRegion
	Select Case RegionID 
		Case 0: Return FrontCamReg
		Case 1: Return RearCamReg
		Case 2: Return LastReg
	End Select
End Sub

'RegionID: -1=Current camera, 0=front, 1=rear
Sub RegionToString(RegionID As Int) As String
	If RegionID = -1 Then RegionID = CurrentRegion
	Dim Region As Rect = FaceRegions(RegionID)
	Return Region.Left & "," & Region.Top & "," & Region.Right & "," & Region.Bottom
End Sub
Sub CurrentRegion As Int 
	If Front Then Return 0 
	Return 1
End Sub

Sub GetPositionOf(jo As JavaObject, FacePart As String) As point 
	Dim temp As point, mouth As JavaObject
	temp.Initialize
	If jo.IsInitialized Then
		mouth = jo.GetField(FacePart)
		temp.X = mouth.GetField("x")
		temp.Y = mouth.GetField("y")
	End If 
	Return temp 
End Sub

'-1000 becomes 0, 0 beomes 50%, 1000 becomes 100%
Sub ScaleFace(XY As Int, WH As Int, Invert As Boolean) As Int 
	XY = (XY + 1000) * 0.0005 * WH '(1*0.0005 = 1/2000)
	If Invert Then Return WH - XY 
	Return XY 
End Sub

Public Sub StartFaceDetection As Boolean
	If CamIsInitialized Then
		Dim jo As JavaObject = nativeCam
		If SetFaceDetectionListener Then 
			Log("FACE DETECTION ON")
			jo.RunMethod("startFaceDetection", Null)
			Return True
		End If
	End If 
	Log("FACE DETECTION FAILED")
End Sub

Public Sub StopFaceDetection
	Dim jo As JavaObject = nativeCam
	jo.RunMethod("stopFaceDetection", Null)
End Sub

Sub ForceReset
	FrontCamReg = SetRect(0,0,0,0)
	RearCamReg = SetRect(0,0,0,0)
	LastReg = SetRect(0,0,0,0)
End Sub
'Resets the calibration data. If OnlyIfDefault=true, it will only reset the data if it's the default data.
public Sub ResetFaceRegions(OnlyIfDefault As Boolean) As Boolean 
	Dim temp As Int 
	If OnlyIfDefault And Not(IsDefault) Then Return False
	ForceReset
	Return True 
End Sub
Sub LoadFaceRegions
	'If Not(FrontCamReg.IsInitialized) Then
		Dim Dir As String = File.Combine(File.DirRootExternal, "Android"), Filename As String = "faceregion.ini"
		If File.Exists(Dir, Filename) Then
			AllRegions = File.ReadMap(Dir, Filename)
		Else
			AllRegions.Initialize
			IsDefault=True
		End If		
		LastReg = SetRect(0,0,0,0)
		LoadRegionOrientation(-1)
		NeedsSaving=False 
		Log("STAGE 2: Face Region data loaded")
	'End If
End Sub

Sub SaveRegions(Orientation As Int)
	Log("STAGE 5: Save orientation: " & Orientation)
	SaveFaceRegion(AllRegions, FrontCamReg, "front_" & Orientation)
	SaveFaceRegion(AllRegions, RearCamReg, "rear_" & Orientation)
End Sub
Sub LoadRegionOrientation(PreviousOrientation As Int)
	If PreviousOrientation >-1 Then SaveRegions(PreviousOrientation)
	Log("STAGE 3: Save " & PreviousOrientation & " & Load " & ActualOrientation)
	FrontCamReg = GetFaceRegion(AllRegions, "front_" & ActualOrientation)
	RearCamReg = GetFaceRegion(AllRegions, "rear_" & ActualOrientation)
	If NeedsSaving Then SaveFaceRegions
End Sub
Sub GetFaceRegion(Data As Map, Name As String) As Rect
	Dim temp As Rect
	temp.Initialize(Data.GetDefault(Name & "_left", 0), Data.GetDefault(Name & "_top", 0), Data.GetDefault(Name & "_right", 0), Data.GetDefault(Name & "_bottom", 0))
	Return temp
End Sub
public Sub SaveFaceRegions
	Dim Dir As String = File.Combine(File.DirRootExternal, "Android"), Filename As String = "faceregion.ini"
	SaveRegions(ActualOrientation)
	File.WriteMap(Dir, Filename, AllRegions)
	NeedsSaving=False 
	Log("STAGE 10: SAVE")
End Sub
Sub SaveFaceRegion(Data As Map, FaceRegion As Rect, Name As String)
	Data.Put(Name & "_left", FaceRegion.Left)
	Data.Put(Name & "_top", FaceRegion.Top)
	Data.Put(Name & "_right", FaceRegion.Right)
	Data.Put(Name & "_bottom", FaceRegion.Bottom)
End Sub
'Code merged from Class module version 1.21 by Jim Brown
'See this page For the list of constants:
'http://developer.android.com/intl/fr/reference/android/hardware/Camera.Parameters.html
'Note that you should use the constant values instead of the names.

'PreviewFormat
'17  = NV21 (YCrCb) 'default
'R = Y + 1.402 * (Cr-128)
'G = Y - 0.34414 * (Cb-128) - 0.71414 * (Cr-128)
'B = Y + 1.772 * (Cb-128)
